## trace-cmd 3.1

=== Makefile ===
# SPDX-License-Identifier: GPL-2.0
# trace-cmd version
TC_VERSION = 3
TC_PATCHLEVEL = 1
TC_EXTRAVERSION = 0
TRACECMD_VERSION = $(TC_VERSION).$(TC_PATCHLEVEL).$(TC_EXTRAVERSION)

export TC_VERSION
export TC_PATCHLEVEL
export TC_EXTRAVERSION
export TRACECMD_VERSION

LIBTC_VERSION = 1
LIBTC_PATCHLEVEL = 1
LIBTC_EXTRAVERSION = 3
LIBTRACECMD_VERSION = $(LIBTC_VERSION).$(LIBTC_PATCHLEVEL).$(LIBTC_EXTRAVERSION)

export LIBTC_VERSION
export LIBTC_PATCHLEVEL
export LIBTC_EXTRAVERSION
export LIBTRACECMD_VERSION

VERSION_FILE = ltc_version.h

LIBTRACEEVENT_MIN_VERSION = 1.5
LIBTRACEFS_MIN_VERSION = 1.4

MAKEFLAGS += --no-print-directory

# Makefiles suck: This macro sets a default value of $(2) for the
# variable named by $(1), unless the variable has been set by
# environment or command line. This is necessary for CC and AR
# because make sets default values, so the simpler ?= approach
# won't work as expected.
define allow-override
  $(if $(or $(findstring environment,$(origin $(1))),\
            $(findstring command line,$(origin $(1)))),,\
    $(eval $(1) = $(2)))
endef

# Allow setting CC and AR, or setting CROSS_COMPILE as a prefix.
$(call allow-override,CC,$(CROSS_COMPILE)gcc)
$(call allow-override,AR,$(CROSS_COMPILE)ar)
$(call allow-override,PKG_CONFIG,pkg-config)
$(call allow-override,LD_SO_CONF_PATH,/etc/ld.so.conf.d/)
$(call allow-override,LDCONFIG,ldconfig)

export LD_SO_CONF_PATH LDCONFIG

EXT = -std=gnu99
INSTALL = install

# Use DESTDIR for installing into a different root directory.
# This is useful for building a package. The program will be
# installed in this directory as if it was the root directory.
# Then the build tool can move it later.
DESTDIR ?=
DESTDIR_SQ = '$(subst ','\'',$(DESTDIR))'

LP64 := $(shell echo __LP64__ | ${CC} ${CFLAGS} -E -x c - | tail -n 1)
ifeq ($(LP64), 1)
  libdir_relative_temp = lib64
else
  libdir_relative_temp = lib
endif

libdir_relative ?= $(libdir_relative_temp)
prefix ?= /usr/local
bindir_relative = bin
bindir = $(prefix)/$(bindir_relative)
man_dir = $(prefix)/share/man
man_dir_SQ = '$(subst ','\'',$(man_dir))'
html_install_SQ = '$(subst ','\'',$(html_install))'
img_install_SQ = '$(subst ','\'',$(img_install))'
libdir = $(prefix)/$(libdir_relative)
libdir_SQ = '$(subst ','\'',$(libdir))'
includedir = $(prefix)/include
includedir_SQ = '$(subst ','\'',$(includedir))'
pkgconfig_dir ?= $(word 1,$(shell $(PKG_CONFIG) 		\
			--variable pc_path pkg-config | tr ":" " "))

etcdir ?= /etc
etcdir_SQ = '$(subst ','\'',$(etcdir))'

export man_dir man_dir_SQ html_install html_install_SQ INSTALL
export img_install img_install_SQ libdir libdir_SQ includedir_SQ
export DESTDIR DESTDIR_SQ

ifeq ($(prefix),$(HOME))
plugin_tracecmd_dir = $(libdir)/trace-cmd/plugins
python_dir ?= $(libdir)/trace-cmd/python
var_dir = $(HOME)/.trace-cmd/
else
python_dir ?= $(libdir)/trace-cmd/python
PLUGIN_DIR_TRACECMD = -DPLUGIN_TRACECMD_DIR="$(plugin_tracecmd_dir)"
PYTHON_DIR = -DPYTHON_DIR="$(python_dir)"
PLUGIN_DIR_TRACECMD_SQ = '$(subst ','\'',$(PLUGIN_DIR_TRACECMD))'
PYTHON_DIR_SQ = '$(subst ','\'',$(PYTHON_DIR))'
var_dir = /var
endif

# Shell quotes
bindir_SQ = $(subst ','\'',$(bindir))
bindir_relative_SQ = $(subst ','\'',$(bindir_relative))
plugin_tracecmd_dir_SQ = $(subst ','\'',$(plugin_tracecmd_dir))
python_dir_SQ = $(subst ','\'',$(python_dir))

pound := \#

VAR_DIR = -DVAR_DIR="$(var_dir)"
VAR_DIR_SQ = '$(subst ','\'',$(VAR_DIR))'
var_dir_SQ = '$(subst ','\'',$(var_dir))'

HELP_DIR = -DHELP_DIR=$(html_install)
HELP_DIR_SQ = '$(subst ','\'',$(HELP_DIR))'
#' emacs highlighting gets confused by the above escaped quote.

BASH_COMPLETE_DIR ?= $(etcdir)/bash_completion.d

export PLUGIN_DIR_TRACECMD
export PYTHON_DIR
export PYTHON_DIR_SQ
export plugin_tracecmd_dir_SQ
export python_dir_SQ
export var_dir

# copy a bit from Linux kbuild

ifeq ("$(origin V)", "command line")
  VERBOSE = $(V)
endif
ifndef VERBOSE
  VERBOSE = 0
endif

SILENT := $(if $(findstring s,$(filter-out --%,$(MAKEFLAGS))),1)

SWIG_DEFINED := $(shell if command -v swig; then echo 1; else echo 0; fi)
ifeq ($(SWIG_DEFINED), 0)
BUILD_PYTHON := report_noswig
NO_PYTHON = 1
endif

ifndef NO_PYTHON
PYTHON		:= ctracecmd.so

PYTHON_VERS ?= python
PYTHON_PKGCONFIG_VERS ?= $(PYTHON_VERS)

# Can build python?
ifeq ($(shell sh -c "$(PKG_CONFIG) --cflags $(PYTHON_PKGCONFIG_VERS) > /dev/null 2>&1 && echo y"), y)
	BUILD_PYTHON := $(PYTHON)
	BUILD_PYTHON_WORKS := 1
else
	BUILD_PYTHON := report_nopythondev
	NO_PYTHON = 1
endif
endif # NO_PYTHON

export BUILD_PYTHON_WORKS
export NO_PYTHON

# $(call test-build, snippet, ret) -> ret if snippet compiles
#                                  -> empty otherwise
test-build = $(if $(shell sh -c 'echo "$(1)" | \
	$(CC) -o /dev/null -x c - > /dev/null 2>&1 && echo y'), $2)

UDIS86_AVAILABLE := $(call test-build,\#include <udis86.h>, y)
ifneq ($(strip $(UDIS86_AVAILABLE)), y)
NO_UDIS86 := 1
endif

ifndef NO_UDIS86
# have udis86 disassembler library?
udis86-flags := -DHAVE_UDIS86 -ludis86
udis86-ldflags := -ludis86
endif # NO_UDIS86

define BLK_TC_FLUSH_SOURCE
#include <linux/blktrace_api.h>
int main(void) { return BLK_TC_FLUSH; }
endef

# have flush/fua block layer instead of barriers?
blk-flags := $(call test-build,$(BLK_TC_FLUSH_SOURCE),-DHAVE_BLK_TC_FLUSH)

define MEMFD_CREATE_SOURCE
#define _GNU_SOURCE
#include <sys/mman.h>
int main(void) { return memfd_create(\"test\", 0); }
endef

# have memfd_create available
memfd-flags := $(call test-build,$(MEMFD_CREATE_SOURCE),-DHAVE_MEMFD_CREATE)

ifeq ("$(origin O)", "command line")

  saved-output := $(O)
  BUILD_OUTPUT := $(shell cd $(O) && /bin/pwd)
  $(if $(BUILD_OUTPUT),, \
    $(error output directory "$(saved-output)" does not exist))

else
  BUILD_OUTPUT = $(CURDIR)
endif

srctree		:= $(if $(BUILD_SRC),$(BUILD_SRC),$(CURDIR))
objtree		:= $(BUILD_OUTPUT)
src		:= $(srctree)
obj		:= $(objtree)

PKG_CONFIG_SOURCE_FILE = libtracecmd.pc
PKG_CONFIG_FILE := $(addprefix $(BUILD_OUTPUT)/,$(PKG_CONFIG_SOURCE_FILE))

export pkgconfig_dir PKG_CONFIG_FILE

export prefix bindir src obj

LIBS = -ldl

LIBTRACECMD_DIR = $(obj)/lib/trace-cmd
LIBTRACECMD_STATIC = $(LIBTRACECMD_DIR)/libtracecmd.a
LIBTRACECMD_SHARED = $(LIBTRACECMD_DIR)/libtracecmd.so.$(LIBTRACECMD_VERSION)
LIBTRACECMD_SHARED_VERSION = $(shell echo $(LIBTRACECMD_SHARED) | sed -e 's/\(\.so\.[0-9]*\).*/\1/')
LIBTRACECMD_SHARED_SO = $(shell echo $(LIBTRACECMD_SHARED) | sed -e 's/\(\.so\).*/\1/')

export LIBTRACECMD_STATIC LIBTRACECMD_SHARED
export LIBTRACECMD_SHARED_VERSION LIBTRACECMD_SHARED_SO

LIBTRACEEVENT=libtraceevent
LIBTRACEFS=libtracefs

TEST_LIBTRACEEVENT = $(shell sh -c "$(PKG_CONFIG) --atleast-version $(LIBTRACEEVENT_MIN_VERSION) $(LIBTRACEEVENT) > /dev/null 2>&1 && echo y")
TEST_LIBTRACEFS = $(shell sh -c "$(PKG_CONFIG) --atleast-version $(LIBTRACEFS_MIN_VERSION) $(LIBTRACEFS) > /dev/null 2>&1 && echo y")

ifeq ("$(TEST_LIBTRACEEVENT)", "y")
LIBTRACEEVENT_CFLAGS = $(shell sh -c "$(PKG_CONFIG) --cflags $(LIBTRACEEVENT)")
LIBTRACEEVENT_LDLAGS = $(shell sh -c "$(PKG_CONFIG) --libs $(LIBTRACEEVENT)")
else
.PHONY: warning
warning:
	@echo "********************************************"
	@echo "** NOTICE: libtraceevent version $(LIBTRACEEVENT_MIN_VERSION) or higher not found on system"
	@echo "**"
	@echo "** Consider installing the latest libtraceevent from your"
	@echo "** distribution, or from source:"
	@echo "**"
	@echo "**  https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/ "
	@echo "**"
	@echo "********************************************"
endif

export LIBTRACEEVENT_CFLAGS LIBTRACEEVENT_LDLAGS

ifeq ("$(TEST_LIBTRACEFS)", "y")
LIBTRACEFS_CFLAGS = $(shell sh -c "$(PKG_CONFIG) --cflags $(LIBTRACEFS)")
LIBTRACEFS_LDLAGS = $(shell sh -c "$(PKG_CONFIG) --libs $(LIBTRACEFS)")
else
.PHONY: warning
warning:
	@echo "********************************************"
	@echo "** NOTICE: libtracefs version $(LIBTRACEFS_MIN_VERSION) or higher not found on system"
	@echo "**"
	@echo "** Consider installing the latest libtracefs from your"
	@echo "** distribution, or from source:"
	@echo "**"
	@echo "**  https://git.kernel.org/pub/scm/libs/libtrace/libtracefs.git/ "
	@echo "**"
	@echo "********************************************"
endif

export LIBTRACEFS_CFLAGS LIBTRACEFS_LDLAGS

TRACE_LIBS = -L$(LIBTRACECMD_DIR) -ltracecmd	\
	     $(LIBTRACEEVENT_LDLAGS) $(LIBTRACEFS_LDLAGS)

export LIBS TRACE_LIBS
export LIBTRACECMD_DIR
export Q SILENT VERBOSE EXT

# Include the utils
include scripts/utils.mk

INCLUDES = -I$(src)/include -I$(src)/../../include
INCLUDES += -I$(src)/include/trace-cmd
INCLUDES += -I$(src)/lib/trace-cmd/include
INCLUDES += -I$(src)/lib/trace-cmd/include/private
INCLUDES += -I$(src)/tracecmd/include
INCLUDES += $(LIBTRACEEVENT_CFLAGS)
INCLUDES += $(LIBTRACEFS_CFLAGS)

include $(src)/features.mk

# Set compile option CFLAGS if not set elsewhere
CFLAGS ?= -g -Wall
CPPFLAGS ?=
LDFLAGS ?=

ifndef NO_VSOCK
VSOCK_DEFINED := $(shell if (echo "$(pound)include <linux/vm_sockets.h>" | $(CC) -E - >/dev/null 2>&1) ; then echo 1; else echo 0 ; fi)
else
VSOCK_DEFINED := 0
endif

export VSOCK_DEFINED
ifeq ($(VSOCK_DEFINED), 1)
CFLAGS += -DVSOCK
endif

PERF_DEFINED := $(shell if (echo "$(pound)include <linux/perf_event.h>" | $(CC) -E - >/dev/null 2>&1) ; then echo 1; else echo 0 ; fi)
export PERF_DEFINED
ifeq ($(PERF_DEFINED), 1)
CFLAGS += -DPERF
endif

ZLIB_INSTALLED := $(shell if (printf "$(pound)include <zlib.h>\n void main(){deflateInit(NULL, Z_BEST_COMPRESSION);}" | $(CC) -o /dev/null -x c - -lz >/dev/null 2>&1) ; then echo 1; else echo 0 ; fi)
ifeq ($(ZLIB_INSTALLED), 1)
export ZLIB_INSTALLED
CFLAGS += -DHAVE_ZLIB
$(info    Have zlib compression support)
endif

TEST_LIBZSTD = $(shell sh -c "$(PKG_CONFIG) --atleast-version 1.4.0 libzstd > /dev/null 2>&1 && echo y")

ifeq ("$(TEST_LIBZSTD)", "y")
LIBZSTD_CFLAGS = $(shell sh -c "$(PKG_CONFIG) --cflags libzstd")
LIBZSTD_LDLAGS = $(shell sh -c "$(PKG_CONFIG) --libs libzstd")
CFLAGS += -DHAVE_ZSTD
ZSTD_INSTALLED=1
$(info    Have ZSTD compression support)
else
$(info	  *************************************************************)
$(info	  ZSTD package not found, best compression algorithm not in use)
$(info	  *************************************************************)
endif

export LIBZSTD_CFLAGS LIBZSTD_LDLAGS ZSTD_INSTALLED

CUNIT_INSTALLED := $(shell if (printf "$(pound)include <CUnit/Basic.h>\n void main(){CU_initialize_registry();}" | $(CC) -o /dev/null -x c - -lcunit >/dev/null 2>&1) ; then echo 1; else echo 0 ; fi)
export CUNIT_INSTALLED

export CFLAGS
export INCLUDES

# Required CFLAGS
override CFLAGS += -D_GNU_SOURCE

ifndef NO_PTRACE
ifneq ($(call try-cc,$(SOURCE_PTRACE),),y)
	NO_PTRACE = 1
	override CFLAGS += -DWARN_NO_PTRACE
endif
endif

ifdef NO_PTRACE
override CFLAGS += -DNO_PTRACE
endif

ifndef NO_AUDIT
ifneq ($(call try-cc,$(SOURCE_AUDIT),-laudit),y)
	NO_AUDIT = 1
	override CFLAGS += -DWARN_NO_AUDIT
endif
endif

ifdef NO_AUDIT
override CFLAGS += -DNO_AUDIT
else
LIBS += -laudit
endif

# Append required CFLAGS
override CFLAGS += $(INCLUDES) $(VAR_DIR)
override CFLAGS += $(PLUGIN_DIR_TRACECMD_SQ)
override CFLAGS += $(udis86-flags) $(blk-flags) $(memfd-flags)
override LDFLAGS += $(udis86-ldflags)

CMD_TARGETS = trace-cmd $(BUILD_PYTHON)

###
#    Default we just build trace-cmd
#
#    If you want all libraries, then do: make libs
###

all: all_cmd plugins show_other_make

all_cmd: $(CMD_TARGETS)

BUILD_PREFIX := $(BUILD_OUTPUT)/build_prefix

$(BUILD_PREFIX): force
	$(Q)$(call build_prefix,$(prefix))

$(PKG_CONFIG_FILE) : ${PKG_CONFIG_SOURCE_FILE}.template $(BUILD_PREFIX) $(VERSION_FILE)
	$(Q) $(call do_make_pkgconfig_file,$(prefix))

trace-cmd: force $(LIBTRACECMD_STATIC) \
	force $(obj)/lib/trace-cmd/plugins/tracecmd_plugin_dir
	$(Q)$(MAKE) -C $(src)/tracecmd $(obj)/tracecmd/$@

$(LIBTRACECMD_STATIC): force
	$(Q)$(MAKE) -C $(src)/lib/trace-cmd $@

$(LIBTRACECMD_SHARED): force
	$(Q)$(MAKE) -C $(src)/lib/trace-cmd libtracecmd.so

libtracecmd.a: $(LIBTRACECMD_STATIC)
libtracecmd.so: $(LIBTRACECMD_SHARED)

=== tracecmd/Makefile ===
# SPDX-License-Identifier: GPL-2.0

VERSION := $(TC_VERSION)
PATCHLEVEL := $(TC_PATCHLEVEL)
EXTRAVERSION := $(TC_EXTRAVERSION)

bdir:=$(obj)/tracecmd

TC_VERSION := $(bdir)/include/tc_version.h
TARGETS = $(bdir)/trace-cmd $(TC_VERSION)

BUILDGUI := 0
include $(src)/scripts/utils.mk

CFLAGS += -I$(bdir)/include

TRACE_CMD_OBJS =
TRACE_CMD_OBJS += trace-cmd.o
TRACE_CMD_OBJS += trace-record.o
TRACE_CMD_OBJS += trace-read.o
TRACE_CMD_OBJS += trace-split.o
TRACE_CMD_OBJS += trace-listen.o
TRACE_CMD_OBJS += trace-stack.o
TRACE_CMD_OBJS += trace-hist.o
TRACE_CMD_OBJS += trace-mem.o
TRACE_CMD_OBJS += trace-snapshot.o
TRACE_CMD_OBJS += trace-stat.o
TRACE_CMD_OBJS += trace-profile.o
TRACE_CMD_OBJS += trace-stream.o
TRACE_CMD_OBJS += trace-record.o
TRACE_CMD_OBJS += trace-restore.o
TRACE_CMD_OBJS += trace-check-events.o
TRACE_CMD_OBJS += trace-show.o
TRACE_CMD_OBJS += trace-list.o
TRACE_CMD_OBJS += trace-usage.o
TRACE_CMD_OBJS += trace-dump.o
TRACE_CMD_OBJS += trace-clear.o
TRACE_CMD_OBJS += trace-vm.o
TRACE_CMD_OBJS += trace-convert.o
TRACE_CMD_OBJS += trace-agent.o
TRACE_CMD_OBJS += trace-tsync.o
TRACE_CMD_OBJS += trace-setup-guest.o
ifeq ($(VSOCK_DEFINED), 1)
TRACE_CMD_OBJS += trace-vsock.o
endif

ALL_OBJS := $(TRACE_CMD_OBJS:%.o=$(bdir)/%.o)

all_objs := $(sort $(ALL_OBJS))
all_deps := $(all_objs:$(bdir)/%.o=$(bdir)/.%.d)

CONFIG_INCLUDES =
CONFIG_LIBS	= -lrt -lpthread $(TRACE_LIBS) $(LIBZSTD_LDLAGS)
CONFIG_FLAGS	=

ifeq ($(ZLIB_INSTALLED), 1)
CONFIG_LIBS += -lz
endif

all: $(TARGETS)

$(bdir):
	@mkdir -p $(bdir)

$(bdir)/include: | $(bdir)
	@mkdir -p $(bdir)/include

$(TC_VERSION): force | $(bdir)/include
	$(Q)$(call update_version.h)

$(all_deps): | $(bdir)
$(all_objs): | $(bdir)

$(bdir)/trace-cmd: $(ALL_OBJS)
	$(Q)$(do_app_build)

$(bdir)/trace-cmd: $(LIBTRACECMD_STATIC)

$(bdir)/%.o: %.c
	$(Q)$(call do_compile)

$(all_deps): $(bdir)/.%.d: %.c
	$(Q)$(CC) -M -MT $(bdir)/$*.o $(CPPFLAGS) $(CFLAGS) $< > $@

$(all_deps): $(TC_VERSION)

$(all_objs): $(bdir)/%.o : $(bdir)/.%.d

dep_includes := $(wildcard $(DEPS))

ifneq ($(dep_includes),)
  include $(dep_includes)
endif

clean:
	$(RM) $(bdir)/*.a $(bdir)/*.so $(bdir)/*.o $(bdir)/.*.d $(TARGETS)

force:
.PHONY: clean

=== lib/trace-cmd/Makefile ===
# SPDX-License-Identifier: GPL-2.0

include $(src)/scripts/utils.mk

bdir:=$(obj)/lib/trace-cmd
ldir:=$(src)/lib/trace-cmd

DEFAULT_TARGET = $(LIBTRACECMD_STATIC)

OBJS =
OBJS += trace-hash.o
OBJS += trace-hooks.o
OBJS += trace-input.o
OBJS += trace-output.o
OBJS += trace-recorder.o
OBJS += trace-util.o
OBJS += trace-filter-hash.o
OBJS += trace-msg.o
OBJS += trace-plugin.o
ifeq ($(PERF_DEFINED), 1)
OBJS += trace-perf.o
endif
OBJS += trace-timesync.o
OBJS += trace-timesync-ptp.o
ifeq ($(VSOCK_DEFINED), 1)
OBJS += trace-timesync-kvm.o
endif
OBJS += trace-compress.o
ifeq ($(ZLIB_INSTALLED), 1)
OBJS += trace-compress-zlib.o
endif
ifeq ($(ZSTD_INSTALLED), 1)
OBJS += trace-compress-zstd.o
endif

# Additional util objects
OBJS += trace-blk-hack.o
OBJS += trace-ftrace.o

OBJS := $(OBJS:%.o=$(bdir)/%.o)
DEPS := $(OBJS:$(bdir)/%.o=$(bdir)/.%.d)

all: $(DEFAULT_TARGET)

$(bdir):
	@mkdir -p $(bdir)

$(OBJS): | $(bdir)
$(DEPS): | $(bdir)

$(LIBTRACECMD_STATIC): $(OBJS)
	$(Q)$(call do_build_static_lib)

LIBS = $(LIBTRACEEVENT_LDLAGS) $(LIBTRACEFS_LDLAGS) $(LIBZSTD_LDLAGS) -lpthread

ifeq ($(ZLIB_INSTALLED), 1)
LIBS += -lz
endif

$(LIBTRACECMD_SHARED_VERSION): $(LIBTRACECMD_SHARED)
	@ln -sf $(<F) $@

$(LIBTRACECMD_SHARED_SO): $(LIBTRACECMD_SHARED_VERSION)
	@ln -sf $(<F) $@

libtracecmd.so: force $(LIBTRACECMD_SHARED_SO)

$(LIBTRACECMD_SHARED): $(OBJS)
	$(Q)$(call do_compile_shared_library,$(notdir $(LIBTRACECMD_SHARED_VERSION)))

$(bdir)/%.o: %.c
	$(Q)$(call do_fpic_compile)

$(DEPS): $(bdir)/.%.d: %.c
	$(Q)$(CC) -M -MT $(bdir)/$*.o $(CPPFLAGS) $(CFLAGS) $< > $@

$(OBJS): $(bdir)/%.o : $(bdir)/.%.d

ifeq ("$(DESTDIR)", "")
# If DESTDIR is not defined, then test if after installing the library
# and running ldconfig, if the library is visible by ld.so.
# If not, add the path to /etc/ld.so.conf.d/trace.conf and run ldconfig again.
define install_ld_config
	if $(LDCONFIG); then \
		if ! grep -q "^$(libdir)$$" $(LD_SO_CONF_PATH)/* ; then \
			echo here;\
			$(CC) -o $(bdir)/test $(ldir)/test.c -I $(includedir_SQ) \
				-L $(libdir_SQ) -ltracecmd &> /dev/null; \
			if ! $(bdir)/test &> /dev/null; then \
				$(call print_install,trace.conf,$(LD_SO_CONF_PATH)) \
				echo $(libdir_SQ) >> $(LD_SO_CONF_PATH)/trace.conf; \
				$(LDCONFIG); \
			fi; \
			$(RM) $(bdir)/test; \
		fi; \
	fi
endef
else
# If installing to a location for another machine or package, do not bother
# with running ldconfig.
define install_ld_config
endef
endif # DESTDIR = ""

install_pkgconfig: $(PKG_CONFIG_FILE)
	$(Q)$(call do_install_pkgconfig_file,$(prefix))

install_libs: install_pkgconfig
	$(Q)$(call do_install,$(LIBTRACECMD_SHARED),$(libdir_SQ))
	$(Q)$(call print_install,$(LIBTRACECMD_SHARED_VERSION),$(DESTDIR)$(libdir_SQ))
	$(Q)cp -fpR $(LIBTRACECMD_SHARED_VERSION) $(DESTDIR)$(libdir_SQ)
	$(Q)$(call print_install,$(LIBTRACECMD_SHARED_SO),$(DESTDIR)$(libdir_SQ))
	$(Q)cp -fpR $(LIBTRACECMD_SHARED_SO) $(DESTDIR)$(libdir_SQ)
	$(Q)$(call do_install,$(src)/include/trace-cmd/trace-cmd.h,$(includedir_SQ)/trace-cmd,644)
	$(Q)$(call install_ld_config)

dep_includes := $(wildcard $(DEPS))

ifneq ($(dep_includes),)
  include $(dep_includes)
endif

clean:
	$(RM) $(bdir)/*.a $(bdir)/*.so $(bdir)/*.so.* $(bdir)/*.o $(bdir)/.*.d

.PHONY: clean

PHONY += force
force:

=== debian/changelog ===
trace-cmd (3.1-1) unstable; urgency=medium

  * Update to upstream v3.1
    - Remove upstream patch.
    - Update copyright.
    - Update symbols.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 09 Jun 2022 21:48:45 +0100

=== debian/control ===
Source: trace-cmd
Section: devel
Priority: optional
Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
Build-Depends:
 debhelper-compat (= 13), asciidoc, docbook-xsl, xsltproc, libcunit1-dev,
 xmlto, pkg-config, libtraceevent-dev, libtracefs-dev, libzstd-dev, source-highlight
Standards-Version: 4.6.0.1
Rules-Requires-Root: no
Vcs-Browser: https://github.com/sudipm-mukherjee/trace-cmd.git
Vcs-Git: https://github.com/sudipm-mukherjee/trace-cmd.git

Package: trace-cmd
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libtraceevent1-plugin
Suggests: kernelshark
Description: Utility for retrieving and analyzing function tracing in the kernel
 This package contains the trace-cmd utility. Trace-cmd makes it easy to
 retrieve and analyze function traces from the Linux kernel while it is running.

Package: libtracecmd1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library for creating and reading trace-cmd data files (shared library)
 The libtracecmd library provides APIs to read trace-cmd data files.
 .
 This package contains the shared library.

Package: libtracecmd-dev
Section: libdevel
Architecture: any
Depends: libtracecmd1 (= ${binary:Version}), ${misc:Depends}
Description: Library for creating and reading trace-cmd data files (development files)
 The libtracecmd library provides APIs to read trace-cmd data files.
 .
 This package is needed to compile programs against libtracecmd1.

## trace-cmd 3.1.4

=== debian/changelog ===
trace-cmd (3.1.4-1) unstable; urgency=medium

  * Update to upstream v3.1.4
    - Update symbols.
    - Update copyright.
  * Update Standards-Version to 4.6.1.0.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 16 Oct 2022 22:17:55 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends:
  debhelper-compat (= 13), asciidoc, docbook-xsl, xsltproc, libcunit1-dev,
  xmlto, pkg-config, libtraceevent-dev, libtracefs-dev, libzstd-dev, source-highlight
-Standards-Version: 4.6.0.1
+Standards-Version: 4.6.1.0
 Rules-Requires-Root: no
 Vcs-Browser: https://github.com/sudipm-mukherjee/trace-cmd.git
 Vcs-Git: https://github.com/sudipm-mukherjee/trace-cmd.git

## trace-cmd 3.1.6

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 # trace-cmd version
 TC_VERSION = 3
 TC_PATCHLEVEL = 1
-TC_EXTRAVERSION = 0
+TC_EXTRAVERSION = 6
 TRACECMD_VERSION = $(TC_VERSION).$(TC_PATCHLEVEL).$(TC_EXTRAVERSION)
 
 export TC_VERSION
@@ -11,8 +11,8 @@
 export TRACECMD_VERSION
 
 LIBTC_VERSION = 1
-LIBTC_PATCHLEVEL = 1
-LIBTC_EXTRAVERSION = 3
+LIBTC_PATCHLEVEL = 3
+LIBTC_EXTRAVERSION = 1
 LIBTRACECMD_VERSION = $(LIBTC_VERSION).$(LIBTC_PATCHLEVEL).$(LIBTC_EXTRAVERSION)
 
 export LIBTC_VERSION
@@ -23,7 +23,7 @@
 VERSION_FILE = ltc_version.h
 
 LIBTRACEEVENT_MIN_VERSION = 1.5
-LIBTRACEFS_MIN_VERSION = 1.4
+LIBTRACEFS_MIN_VERSION = 1.6
 
 MAKEFLAGS += --no-print-directory
 
@@ -216,13 +216,13 @@
 
 export prefix bindir src obj
 
-LIBS = -ldl
+LIBS ?= -ldl
 
 LIBTRACECMD_DIR = $(obj)/lib/trace-cmd
 LIBTRACECMD_STATIC = $(LIBTRACECMD_DIR)/libtracecmd.a
 LIBTRACECMD_SHARED = $(LIBTRACECMD_DIR)/libtracecmd.so.$(LIBTRACECMD_VERSION)
-LIBTRACECMD_SHARED_VERSION = $(shell echo $(LIBTRACECMD_SHARED) | sed -e 's/\(\.so\.[0-9]*\).*/\1/')
-LIBTRACECMD_SHARED_SO = $(shell echo $(LIBTRACECMD_SHARED) | sed -e 's/\(\.so\).*/\1/')
+LIBTRACECMD_SHARED_VERSION := $(shell echo $(LIBTRACECMD_SHARED) | sed -e 's/\(\.so\.[0-9]*\).*/\1/')
+LIBTRACECMD_SHARED_SO := $(shell echo $(LIBTRACECMD_SHARED) | sed -e 's/\(\.so\).*/\1/')
 
 export LIBTRACECMD_STATIC LIBTRACECMD_SHARED
 export LIBTRACECMD_SHARED_VERSION LIBTRACECMD_SHARED_SO
@@ -230,12 +230,12 @@
 LIBTRACEEVENT=libtraceevent
 LIBTRACEFS=libtracefs
 
-TEST_LIBTRACEEVENT = $(shell sh -c "$(PKG_CONFIG) --atleast-version $(LIBTRACEEVENT_MIN_VERSION) $(LIBTRACEEVENT) > /dev/null 2>&1 && echo y")
-TEST_LIBTRACEFS = $(shell sh -c "$(PKG_CONFIG) --atleast-version $(LIBTRACEFS_MIN_VERSION) $(LIBTRACEFS) > /dev/null 2>&1 && echo y")
+TEST_LIBTRACEEVENT := $(shell sh -c "$(PKG_CONFIG) --atleast-version $(LIBTRACEEVENT_MIN_VERSION) $(LIBTRACEEVENT) > /dev/null 2>&1 && echo y")
+TEST_LIBTRACEFS := $(shell sh -c "$(PKG_CONFIG) --atleast-version $(LIBTRACEFS_MIN_VERSION) $(LIBTRACEFS) > /dev/null 2>&1 && echo y")
 
 ifeq ("$(TEST_LIBTRACEEVENT)", "y")
-LIBTRACEEVENT_CFLAGS = $(shell sh -c "$(PKG_CONFIG) --cflags $(LIBTRACEEVENT)")
-LIBTRACEEVENT_LDLAGS = $(shell sh -c "$(PKG_CONFIG) --libs $(LIBTRACEEVENT)")
+LIBTRACEEVENT_CFLAGS := $(shell sh -c "$(PKG_CONFIG) --cflags $(LIBTRACEEVENT)")
+LIBTRACEEVENT_LDLAGS := $(shell sh -c "$(PKG_CONFIG) --libs $(LIBTRACEEVENT)")
 else
 .PHONY: warning
 warning:
@@ -253,8 +253,8 @@
 export LIBTRACEEVENT_CFLAGS LIBTRACEEVENT_LDLAGS
 
 ifeq ("$(TEST_LIBTRACEFS)", "y")
-LIBTRACEFS_CFLAGS = $(shell sh -c "$(PKG_CONFIG) --cflags $(LIBTRACEFS)")
-LIBTRACEFS_LDLAGS = $(shell sh -c "$(PKG_CONFIG) --libs $(LIBTRACEFS)")
+LIBTRACEFS_CFLAGS := $(shell sh -c "$(PKG_CONFIG) --cflags $(LIBTRACEFS)")
+LIBTRACEFS_LDLAGS := $(shell sh -c "$(PKG_CONFIG) --libs $(LIBTRACEFS)")
 else
 .PHONY: warning
 warning:
@@ -316,15 +316,19 @@
 ZLIB_INSTALLED := $(shell if (printf "$(pound)include <zlib.h>\n void main(){deflateInit(NULL, Z_BEST_COMPRESSION);}" | $(CC) -o /dev/null -x c - -lz >/dev/null 2>&1) ; then echo 1; else echo 0 ; fi)
 ifeq ($(ZLIB_INSTALLED), 1)
 export ZLIB_INSTALLED
+ZLIB_LDLAGS = -lz
 CFLAGS += -DHAVE_ZLIB
 $(info    Have zlib compression support)
 endif
 
-TEST_LIBZSTD = $(shell sh -c "$(PKG_CONFIG) --atleast-version 1.4.0 libzstd > /dev/null 2>&1 && echo y")
+export ZLIB_LDLAGS
+
+ifndef NO_LIBZSTD
+TEST_LIBZSTD := $(shell sh -c "$(PKG_CONFIG) --atleast-version 1.4.0 libzstd > /dev/null 2>&1 && echo y")
 
 ifeq ("$(TEST_LIBZSTD)", "y")
-LIBZSTD_CFLAGS = $(shell sh -c "$(PKG_CONFIG) --cflags libzstd")
-LIBZSTD_LDLAGS = $(shell sh -c "$(PKG_CONFIG) --libs libzstd")
+LIBZSTD_CFLAGS := $(shell sh -c "$(PKG_CONFIG) --cflags libzstd")
+LIBZSTD_LDLAGS := $(shell sh -c "$(PKG_CONFIG) --libs libzstd")
 CFLAGS += -DHAVE_ZSTD
 ZSTD_INSTALLED=1
 $(info    Have ZSTD compression support)
@@ -335,6 +339,7 @@
 endif
 
 export LIBZSTD_CFLAGS LIBZSTD_LDLAGS ZSTD_INSTALLED
+endif
 
 CUNIT_INSTALLED := $(shell if (printf "$(pound)include <CUnit/Basic.h>\n void main(){CU_initialize_registry();}" | $(CC) -o /dev/null -x c - -lcunit >/dev/null 2>&1) ; then echo 1; else echo 0 ; fi)
 export CUNIT_INSTALLED
@@ -344,6 +349,9 @@
 
 # Required CFLAGS
 override CFLAGS += -D_GNU_SOURCE
+
+# Make sure 32 bit stat() works on large file systems
+override CFLAGS += -D_FILE_OFFSET_BITS=64
 
 ifndef NO_PTRACE
 ifneq ($(call try-cc,$(SOURCE_PTRACE),),y)
@@ -400,11 +408,3 @@
 	$(Q)$(MAKE) -C $(src)/tracecmd $(obj)/tracecmd/$@
 
 $(LIBTRACECMD_STATIC): force
-	$(Q)$(MAKE) -C $(src)/lib/trace-cmd $@
-
-$(LIBTRACECMD_SHARED): force
-	$(Q)$(MAKE) -C $(src)/lib/trace-cmd libtracecmd.so
-
-libtracecmd.a: $(LIBTRACECMD_STATIC)
-libtracecmd.so: $(LIBTRACECMD_SHARED)
-

=== python/Makefile ===
# SPDX-License-Identifier: GPL-2.0

include $(src)/scripts/utils.mk

ifdef BUILD_PYTHON_WORKS
PYTHON_SO_INSTALL := ctracecmd.install
PYTHON_PY_PROGS := event-viewer.install
PYTHON_PY_LIBS := tracecmd.install
endif

ctracecmd.so: ctracecmd.i $(LIBTRACECMD_STATIC)
	swig -Wall -python -noproxy -I$(src)/include/trace-cmd $(LIBTRACEEVENT_CFLAGS) ctracecmd.i
	$(CC) -fpic -c $(CPPFLAGS) $(CFLAGS) $(PYTHON_INCLUDES)  ctracecmd_wrap.c
	$(CC) --shared $(LIBTRACECMD_STATIC) $(LDFLAGS) ctracecmd_wrap.o -o ctracecmd.so $(TRACE_LIBS)

$(PYTHON_SO_INSTALL): %.install : %.so force
	$(Q)$(call do_install_data,$<,$(python_dir_SQ))

$(PYTHON_PY_PROGS): %.install : %.py force
	$(Q)$(call do_install,$<,$(python_dir_SQ))

$(PYTHON_PY_LIBS): %.install : %.py force
	$(Q)$(call do_install_data,$<,$(python_dir_SQ))

install_python: $(PYTHON_SO_INSTALL) $(PYTHON_PY_PROGS) $(PYTHON_PY_LIBS)


clean:
	$(RM) *.a *.so *.o .*.d ctracecmd_wrap.*

force:
.PHONY: clean force

=== tracecmd/Makefile ===
--- 
+++ 
@@ -49,13 +49,12 @@
 all_objs := $(sort $(ALL_OBJS))
 all_deps := $(all_objs:$(bdir)/%.o=$(bdir)/.%.d)
 
+LPTHREAD ?= -lpthread
+LRT ?= -lrt
+
 CONFIG_INCLUDES =
-CONFIG_LIBS	= -lrt -lpthread $(TRACE_LIBS) $(LIBZSTD_LDLAGS)
+CONFIG_LIBS	= $(LRT) $(LPTHREAD) $(TRACE_LIBS) $(ZLIB_LDLAGS) $(LIBZSTD_LDLAGS)
 CONFIG_FLAGS	=
-
-ifeq ($(ZLIB_INSTALLED), 1)
-CONFIG_LIBS += -lz
-endif
 
 all: $(TARGETS)

=== utest/Makefile ===
# SPDX-License-Identifier: GPL-2.0

include $(src)/scripts/utils.mk

bdir:=$(obj)/utest

TARGETS = $(bdir)/trace-utest

OBJS =
OBJS += trace-utest.o
OBJS += tracecmd-utest.o

LIBS += $(LIBTRACECMD_STATIC) -lcunit $(LIBTRACEEVENT_LDLAGS) $(LIBTRACEFS_LDLAGS)

LIBS += $(ZLIB_LDLAGS) $(LIBZSTD_LDLAGS)

OBJS := $(OBJS:%.o=$(bdir)/%.o)
DEPS := $(OBJS:$(bdir)/%.o=$(bdir)/.%.d)

$(bdir):
	@mkdir -p $(bdir)

$(OBJS): | $(bdir)
$(DEPS): | $(bdir)

$(bdir)/trace-utest: $(OBJS) $(LIBTRACECMD_STATIC)
	$(Q)$(do_app_build)

$(bdir)/%.o: %.c
	$(Q)$(call do_fpic_compile)

$(DEPS): $(bdir)/.%.d: %.c
	$(Q)$(CC) -M $(CPPFLAGS) $(CFLAGS) $< > $@
	$(Q)$(CC) -M -MT $(bdir)/$*.o $(CPPFLAGS) $(CFLAGS) $< > $@

$(OBJS): $(bdir)/%.o : $(bdir)/.%.d

dep_includes := $(wildcard $(DEPS))

test: $(TARGETS)

clean:
	$(RM) $(TARGETS) $(bdir)/*.o $(bdir)/.*.d

=== lib/trace-cmd/plugins/Makefile ===
include $(src)/scripts/utils.mk

bdir:=$(obj)/lib/trace-cmd/plugins

PLUGIN_OBJS =

PLUGIN_OBJS := $(PLUGIN_OBJS:%.o=$(bdir)/%.o)
PLUGIN_BUILD := $(PLUGIN_OBJS:$(bdir)/%.o=$(bdir)/%.so)

PLUGINS := $(PLUGIN_BUILD)

DEPS := $(PLUGIN_OBJS:$(bdir)/%.o=$(bdir)/.%.d)

all: $(PLUGINS)

$(bdir):
	@mkdir -p $(bdir)

$(PLUGIN_OBJS): | $(bdir)
$(DEPS): | $(bdir)

$(PLUGIN_OBJS): $(bdir)/%.o : %.c
	$(Q)$(do_compile_plugin_obj)

$(PLUGIN_BUILD): $(bdir)/%.so: $(bdir)/%.o
	$(Q)$(do_plugin_build)

$(DEPS): $(bdir)/.%.d: %.c
	$(Q)$(CC) -M -MT $(bdir)/$*.o $(CPPFLAGS) $(CFLAGS) $< > $@

$(PLUGIN_OBJS): $(bdir)/%.o : $(bdir)/.%.d

PLUGINS_INSTALL = $(subst .so,.install,$(PLUGINS))

$(PLUGINS_INSTALL): $(bdir)/%.install : $(bdir)/%.so force
	$(Q)$(call do_install_data,$<,$(plugin_tracecmd_dir_SQ))

install_plugins: $(PLUGINS_INSTALL)

# The following targets are necessary to trigger a rebuild when
# $(PLUGIN_DIR_TRACECMD) change. Without them, a full clean build would
# necessary in order to get the binaries updated.

$(bdir)/tracecmd_plugin_dir: $(bdir) force
	$(Q)$(N)$(call update_dir, 'PLUGIN_DIR_TRACECMD=$(PLUGIN_DIR_TRACECMD)')

dep_includes := $(wildcard $(DEPS))

ifneq ($(dep_includes),)
  include $(dep_includes)
endif

clean:
	$(RM) -f $(bdir)/*.a $(bdir)/*.so $(bdir)/*.o $(bdir)/.*.d\
		$(bdir)/tracecmd_plugin_dir

force:
.PHONY: clean force

=== debian/changelog ===
trace-cmd (3.1.6-1) unstable; urgency=medium

  * New upstream version 3.1.6
    - Update symbols.
  * Update Standards-Version to 4.6.2

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 22 Jan 2023 00:22:02 +0000

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends:
  debhelper-compat (= 13), asciidoc, docbook-xsl, xsltproc, libcunit1-dev,
  xmlto, pkg-config, libtraceevent-dev, libtracefs-dev, libzstd-dev, source-highlight
-Standards-Version: 4.6.1.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Vcs-Browser: https://github.com/sudipm-mukherjee/trace-cmd.git
 Vcs-Git: https://github.com/sudipm-mukherjee/trace-cmd.git

## trace-cmd 3.2

=== Makefile ===
--- 
+++ 
@@ -1,8 +1,8 @@
 # SPDX-License-Identifier: GPL-2.0
 # trace-cmd version
 TC_VERSION = 3
-TC_PATCHLEVEL = 1
-TC_EXTRAVERSION = 6
+TC_PATCHLEVEL = 2
+TC_EXTRAVERSION = 0
 TRACECMD_VERSION = $(TC_VERSION).$(TC_PATCHLEVEL).$(TC_EXTRAVERSION)
 
 export TC_VERSION
@@ -11,8 +11,8 @@
 export TRACECMD_VERSION
 
 LIBTC_VERSION = 1
-LIBTC_PATCHLEVEL = 3
-LIBTC_EXTRAVERSION = 1
+LIBTC_PATCHLEVEL = 4
+LIBTC_EXTRAVERSION = 0
 LIBTRACECMD_VERSION = $(LIBTC_VERSION).$(LIBTC_PATCHLEVEL).$(LIBTC_EXTRAVERSION)
 
 export LIBTC_VERSION

=== tracecmd/Makefile ===
--- 
+++ 
@@ -37,6 +37,7 @@
 TRACE_CMD_OBJS += trace-clear.o
 TRACE_CMD_OBJS += trace-vm.o
 TRACE_CMD_OBJS += trace-convert.o
+TRACE_CMD_OBJS += trace-attach.o
 TRACE_CMD_OBJS += trace-agent.o
 TRACE_CMD_OBJS += trace-tsync.o
 TRACE_CMD_OBJS += trace-setup-guest.o

=== lib/trace-cmd/Makefile ===
--- 
+++ 
@@ -15,8 +15,10 @@
 OBJS += trace-recorder.o
 OBJS += trace-util.o
 OBJS += trace-filter-hash.o
+OBJS += trace-filter.o
 OBJS += trace-msg.o
 OBJS += trace-plugin.o
+OBJS += trace-maps.o
 ifeq ($(PERF_DEFINED), 1)
 OBJS += trace-perf.o
 endif
@@ -51,11 +53,9 @@
 $(LIBTRACECMD_STATIC): $(OBJS)
 	$(Q)$(call do_build_static_lib)
 
-LIBS = $(LIBTRACEEVENT_LDLAGS) $(LIBTRACEFS_LDLAGS) $(LIBZSTD_LDLAGS) -lpthread
+LPTHREAD ?= -lpthread
 
-ifeq ($(ZLIB_INSTALLED), 1)
-LIBS += -lz
-endif
+LIBS = $(LIBTRACEEVENT_LDLAGS) $(LIBTRACEFS_LDLAGS) $(ZLIB_LDLAGS) $(LIBZSTD_LDLAGS) $(LPTHREAD)
 
 $(LIBTRACECMD_SHARED_VERSION): $(LIBTRACECMD_SHARED)
 	@ln -sf $(<F) $@

=== debian/changelog ===
trace-cmd (3.2-1ubuntu2) noble; urgency=medium

  * debian/tests: use consistent skipping conditions for autopkgtest
    (LP: #2060545)

 -- Nick Rosbrook <enr0n@ubuntu.com>  Mon, 08 Apr 2024 12:13:38 -0400

trace-cmd (3.2-1ubuntu1) noble; urgency=medium

  * Address autopkgtest TODOs for MIR (LP: #2051850)
    - debian/tests: add simple autopkgtest using man page examples
    - debian/tests/control: run trace-utest as autopkgtest
    - debian/patches: fallback to using /usr/bin/trace-cmd in trace-utest

 -- Nick Rosbrook <enr0n@ubuntu.com>  Fri, 05 Apr 2024 16:36:49 -0400

trace-cmd (3.2-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Apply multi-arch hints. + libtracecmd1: Add Multi-Arch: same.

  [ Sudip Mukherjee ]
  * New upstream version 3.2
    - Update copyright.
    - Update symbols.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 03 Jul 2023 20:29:04 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: trace-cmd
 Section: devel
 Priority: optional
-Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
 Build-Depends:
  debhelper-compat (= 13), asciidoc, docbook-xsl, xsltproc, libcunit1-dev,
  xmlto, pkg-config, libtraceevent-dev, libtracefs-dev, libzstd-dev, source-highlight
@@ -22,6 +23,7 @@
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Multi-Arch: same
 Description: Library for creating and reading trace-cmd data files (shared library)
  The libtracecmd library provides APIs to read trace-cmd data files.
  .

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk
export DEB_DESTDIR ?= $(CURDIR)/debian/tmp/

%:
	dh $@

OPTS=DESTDIR=$(DEB_DESTDIR) prefix=/usr VERBOSE=$(if $(filter terse,$(DEB_BUILD_OPTIONS)),0,1) libdir_relative=lib/$(DEB_HOST_MULTIARCH) pkgconfig_dir=/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig

override_dh_auto_clean:
	$(MAKE) clean doc_clean $(OPTS)
override_dh_auto_build:
	dh_auto_build -- all $(OPTS)
	$(MAKE) doc $(OPTS)
override_dh_auto_install:
	$(MAKE) install $(OPTS)
	$(MAKE) install_libs $(OPTS)
	$(MAKE) install_doc $(OPTS)

## trace-cmd 3.3

=== debian/changelog ===
trace-cmd (3.3-2) unstable; urgency=medium

  * Add new package for Python bindings.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 17 Aug 2024 00:03:03 +0100

trace-cmd (3.3-1) unstable; urgency=medium

  * New upstream version 3.3
    - Update symbols.
  * Move Vcs to salsa.
    - Enable CI in salsa.
  * Add versioned dependency of libtraceevent-dev and libtracefs-dev.
  * Update Standards-Version to 4.7.0
    - No change needed.
  * Depend on pkgconf instead of pkg-config.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 09 Aug 2024 19:56:08 +0100

## trace-cmd 3.3.1

=== Makefile ===
--- 
+++ 
@@ -1,8 +1,8 @@
 # SPDX-License-Identifier: GPL-2.0
 # trace-cmd version
 TC_VERSION = 3
-TC_PATCHLEVEL = 2
-TC_EXTRAVERSION = 0
+TC_PATCHLEVEL = 3
+TC_EXTRAVERSION = 1
 TRACECMD_VERSION = $(TC_VERSION).$(TC_PATCHLEVEL).$(TC_EXTRAVERSION)
 
 export TC_VERSION
@@ -11,8 +11,8 @@
 export TRACECMD_VERSION
 
 LIBTC_VERSION = 1
-LIBTC_PATCHLEVEL = 4
-LIBTC_EXTRAVERSION = 0
+LIBTC_PATCHLEVEL = 5
+LIBTC_EXTRAVERSION = 2
 LIBTRACECMD_VERSION = $(LIBTC_VERSION).$(LIBTC_PATCHLEVEL).$(LIBTC_EXTRAVERSION)
 
 export LIBTC_VERSION
@@ -23,7 +23,7 @@
 VERSION_FILE = ltc_version.h
 
 LIBTRACEEVENT_MIN_VERSION = 1.5
-LIBTRACEFS_MIN_VERSION = 1.6
+LIBTRACEFS_MIN_VERSION = 1.8
 
 MAKEFLAGS += --no-print-directory
 
@@ -144,7 +144,7 @@
 ifndef NO_PYTHON
 PYTHON		:= ctracecmd.so
 
-PYTHON_VERS ?= python
+PYTHON_VERS ?= python3
 PYTHON_PKGCONFIG_VERS ?= $(PYTHON_VERS)
 
 # Can build python?

=== meson_options.txt ===
# -*- mode: meson -*-
# SPDX-License-Identifier: GPL-2.0

option('version-tag', type : 'string',
       description : 'override the git version string')
option('vsock', type : 'boolean', value : true,
       description : 'build with vsock support')
option('ptrace', type : 'boolean', value : true,
       description : 'build with ptrace support')
option('htmldir', type : 'string', value : 'share/doc/trace-cmd-doc',
       description : 'directory for HTML documentation')
option('asciidoctor', type : 'boolean', value: false,
       description : 'use asciidoctor instead of asciidoc')
option('docbook-xls-172', type : 'boolean', value : false,
       description : 'enable docbook XLS 172 workaround')
option('asciidoc-no-roff', type : 'boolean', value : false,
       description : 'enable no roff workaround')
option('man-bold-literal', type : 'boolean', value : false,
       description : 'enable bold literals')
option('docbook-suppress-sp', type : 'boolean', value : false,
       description : 'docbook suppress sp')
option('python', type : 'combo', choices : ['auto', 'true', 'false'],
       description : 'Generate trac-cmd Python bindings')

=== tracecmd/Makefile ===
--- 
+++ 
@@ -41,6 +41,7 @@
 TRACE_CMD_OBJS += trace-agent.o
 TRACE_CMD_OBJS += trace-tsync.o
 TRACE_CMD_OBJS += trace-setup-guest.o
+TRACE_CMD_OBJS += trace-sqlhist.o
 ifeq ($(VSOCK_DEFINED), 1)
 TRACE_CMD_OBJS += trace-vsock.o
 endif

=== Documentation/trace-cmd/Makefile ===
# SPDX-License-Identifier: GPL-2.0

# Include the utils
include $(src)/scripts/utils.mk

# This Makefile and manpage XSL files were taken from libtracefs
# and modified for libtracecmd

MAN1_TXT= \
	$(wildcard trace-cmd*.1.txt)

MAN5_TXT= \
	$(wildcard trace-cmd*.5.txt)

MAN_TXT = $(MAN1_TXT) $(MAN5_TXT)
_MAN_XML=$(patsubst %.txt,%.xml,$(MAN_TXT))
_MAN_HTML=$(patsubst %.txt,%.html,$(MAN_TXT))
_DOC_MAN1=$(patsubst %.1.txt,%.1,$(MAN1_TXT))
_DOC_MAN5=$(patsubst %.5.txt,%.5,$(MAN5_TXT))

MAN_XML=$(addprefix $(OUTPUT),$(_MAN_XML))
MAN_HTML=$(addprefix $(OUTPUT),$(_MAN_HTML))
DOC_MAN1=$(addprefix $(OUTPUT),$(_DOC_MAN1))
DOC_MAN5=$(addprefix $(OUTPUT),$(_DOC_MAN5))

# Make the path relative to DESTDIR, not prefix
ifndef DESTDIR
prefix?=$(HOME)
endif
bindir?=$(prefix)/bin
htmldir?=$(prefix)/share/doc/trace-cmd
pdfdir?=$(prefix)/share/doc/trace-cmd
mandir?=$(prefix)/share/man
man1dir=$(mandir)/man1
man5dir=$(mandir)/man5

ifdef USE_ASCIIDOCTOR
ASCIIDOC_EXTRA += -a mansource="libtracecmd" -a manmanual="libtracecmd Manual"
endif

all: check-man-tools html man

man: man1 man5
man1: $(DOC_MAN1)
man5: $(DOC_MAN5)

html: $(MAN_HTML)

$(MAN_HTML) $(DOC_MAN1) $(DOC_MAN5): $(ASCIIDOC_CONF)

install: check-man-tools install-man install-html

check-man-tools:
ifdef missing_tools
	$(error "You need to install $(missing_tools) for man pages")
endif

install-%.1: $(OUTPUT)%.1
	$(Q)$(call do_install_docs,$<,$(man1dir),644);

install-%.5: $(OUTPUT)%.5
	$(Q)$(call do_install_docs,$<,$(man5dir),644);

do-install-man: man $(addprefix install-,$(wildcard $(OUTPUT)*.1)) \
	$(addprefix install-,$(wildcard $(OUTPUT)*.5))

install-man: man
	$(Q)$(MAKE) -C . do-install-man

install-%.txt: $(OUTPUT)%.html
	$(Q)$(call do_install_docs,$<,$(htmldir),644);

do-install-html: html $(addprefix install-,$(wildcard *.txt))

install-html: html do-install-html

uninstall: uninstall-man uninstall-html

uninstall-man:
	$(Q)$(RM) $(addprefix $(DESTDIR)$(man1dir)/,$(DOC_MAN1))
	$(Q)$(RM) $(addprefix $(DESTDIR)$(man5dir)/,$(DOC_MAN5))

uninstall-html:
	$(Q)$(RM) $(addprefix $(DESTDIR)$(htmldir)/,$(MAN_HTML))

ifdef missing_tools
  DO_INSTALL_MAN = $(warning Please install $(missing_tools) to have the man pages installed)
else
  DO_INSTALL_MAN = do-install-man
endif

CLEAN_FILES =					\
	$(MAN_XML) $(addsuffix +,$(MAN_XML))	\
	$(MAN_HTML) $(addsuffix +,$(MAN_HTML))	\
	$(DOC_MAN1) $(DOC_MAN5) *.1 *.5

clean:
	$(Q) $(RM) $(CLEAN_FILES)

ifdef USE_ASCIIDOCTOR
$(OUTPUT)%.1 : $(OUTPUT)%.1.txt
	$(QUIET_ASCIIDOC)$(RM) $@+ $@ && \
	$(ASCIIDOC) -b manpage -d manpage \
		$(ASCIIDOC_EXTRA) -atracecmd_version=$(TRACECMD_VERSION) -o $@+ $< && \
	mv $@+ $@

$(OUTPUT)%.5 : $(OUTPUT)%.5.txt
	$(QUIET_ASCIIDOC)$(RM) $@+ $@ && \
	$(ASCIIDOC) -b manpage -d manpage \
		$(ASCIIDOC_EXTRA) -atracecmd_version=$(TRACECMD_VERSION) -o $@+ $< && \
	mv $@+ $@
endif

$(OUTPUT)%.1 : $(OUTPUT)%.1.xml
	$(QUIET_XMLTO)$(RM) $@ && \
	$(XMLTO) -o $(OUTPUT). -m $(MANPAGE_XSL) $(XMLTO_EXTRA) man $<; \

$(OUTPUT)%.5 : $(OUTPUT)%.5.xml
	$(QUIET_XMLTO)$(RM) $@ && \
	$(XMLTO) -o $(OUTPUT). -m $(MANPAGE_XSL) $(XMLTO_EXTRA) man $<; \

$(OUTPUT)%.xml : %.txt
	$(QUIET_ASCIIDOC)$(RM) $@+ $@ && \
	$(ASCIIDOC) -b docbook -d manpage \
		$(ASCIIDOC_EXTRA) -atracecmd_version=$(TRACECMD_VERSION) -o $@+ $< && \
	mv $@+ $@

$(MAN_HTML): $(OUTPUT)%.html : %.txt
	$(QUIET_ASCIIDOC)$(RM) $@+ $@ && \
	$(ASCIIDOC) -b $(ASCIIDOC_HTML) -d manpage \
		$(ASCIIDOC_EXTRA) -atracecmd_version=$(TRACECMD_VERSION) -o $@+ $< && \
	mv $@+ $@

=== debian/changelog ===
trace-cmd (3.3.1-1ubuntu2) questing; urgency=medium

  * trace-utest: run trace-cmd with --compression none on s390x
    (LP: #2114514)
  * trace-utest: return non-zero when tests have failed

 -- Nick Rosbrook <enr0n@ubuntu.com>  Mon, 23 Jun 2025 15:45:56 -0400

trace-cmd (3.3.1-1ubuntu1) questing; urgency=medium

  * Merge with Debian unstable (LP: #2112078). Remaining changes:
    - debian/patches: fallback to using /usr/bin/trace-cmd in trace-utest
    - debian/tests: add trace-utest and trace-cmd-examples dep8 tests
  * Dropped, fixed upstream:
    - debian/patches/0003-include-missing-libgen-header.patch

 -- Nick Rosbrook <enr0n@ubuntu.com>  Thu, 05 Jun 2025 13:26:02 -0400

trace-cmd (3.3.1-1) unstable; urgency=medium

  * New upstream version 3.3.1

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 24 Dec 2024 13:25:26 +0000

=== debian/control ===
--- 
+++ 
@@ -5,11 +5,12 @@
 XSBC-Original-Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
 Build-Depends:
  debhelper-compat (= 13), asciidoc, docbook-xsl, xsltproc, libcunit1-dev,
- xmlto, pkg-config, libtraceevent-dev, libtracefs-dev, libzstd-dev, source-highlight
-Standards-Version: 4.6.2
+ xmlto, pkgconf, libtraceevent-dev (>= 1.5), libtracefs-dev (>= 1.8), libzstd-dev, source-highlight,
+ python3-dev, swig, dh-python
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
-Vcs-Browser: https://github.com/sudipm-mukherjee/trace-cmd.git
-Vcs-Git: https://github.com/sudipm-mukherjee/trace-cmd.git
+Vcs-Browser: https://salsa.debian.org/sudip/trace-cmd
+Vcs-Git: https://salsa.debian.org/sudip/trace-cmd.git
 
 Package: trace-cmd
 Architecture: any
@@ -37,3 +38,11 @@
  The libtracecmd library provides APIs to read trace-cmd data files.
  .
  This package is needed to compile programs against libtracecmd1.
+
+Package: python3-trace-cmd
+Architecture: any
+Section: python
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}
+Description: Python module for analyzing function tracing in the kernel
+ The package contains the Python module to analyze trace from the Linux
+ kernel  generated by trace-cmd.

=== debian/tests/control ===
Test-Command: trace-cmd list
Depends: @
Restrictions: needs-root, allow-stderr, superficial

Tests: trace-utest
Depends: @, @builddeps@
Restrictions: needs-root, isolation-machine, skippable, allow-stderr

Tests: trace-cmd-examples
Depends: @
Restrictions: needs-root, isolation-machine, skippable, allow-stderr
